<?php
class Dropbox{
    public function getAuthURL(){
        $redirect_uri = urlencode(base_url('api/dropbox'));
        return "https://www.dropbox.com/oauth2/authorize?client_id=".DROPBOXAPIKEY."&response_type=code&redirect_uri={$redirect_uri}";
    }

    public function getAccesToken($code){
        $url = urlencode(base_url('api/dropbox'));
        // Generated by curl-to-PHP: http://incarnate.github.io/curl-to-php/
        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, 'https://api.dropbox.com/oauth2/token');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, "code={$code}&grant_type=authorization_code&redirect_uri={$url}");
        curl_setopt($ch, CURLOPT_USERPWD, DROPBOXAPIKEY . ':' . DROPBOXSECRET);

        $headers = array();
        $headers[] = 'Content-Type: application/x-www-form-urlencoded';
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $result = curl_exec($ch);
        if (curl_errno($ch)) {
            echo 'Error:' . curl_error($ch);
        }
        curl_close($ch);

        return $result;
    }

    public function getUserInformation( $accountID, $accessToken ){
        // Generated by curl-to-PHP: http://incarnate.github.io/curl-to-php/
        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, 'https://api.dropboxapi.com/2/users/get_account');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, "{\"account_id\":\"{$accountID}\"}");

        $headers = array();
        $headers[] = "Authorization: Bearer {$accessToken}";
        $headers[] = 'Content-Type: application/json';
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $result = curl_exec($ch);
        if (curl_errno($ch)) {
            echo 'Error:' . curl_error($ch);
        }
        curl_close($ch);

        return $result;
    }

    public function createFolder($accessToken, $folderName){
        // Generated by curl-to-PHP: http://incarnate.github.io/curl-to-php/
        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, 'https://api.dropboxapi.com/2/files/create_folder_v2');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, "{\"path\": \"/{$folderName}\",\"autorename\": false}");

        $headers = array();
        $headers[] = "Authorization: Bearer {$accessToken}";
        $headers[] = 'Content-Type: application/json';
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $result = curl_exec($ch);
        if (curl_errno($ch)) {
            echo 'Error:' . curl_error($ch);
        }
        curl_close($ch);
        return $result;
    }

    public function uploadFile($accessToken, $folderName, $file){
        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, 'https://content.dropboxapi.com/2/files/upload');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, 1);
        $post = array(
            'file' => '@'.$file
        );
        curl_setopt($ch, CURLOPT_POSTFIELDS, file_get_contents($file) );
        $name = basename($file);
        $args = array(
            "path" => '/'.$folderName.'/'.$name,
            "mode" => "add"
        );
        $headers = array();
        $headers[] = "Authorization: Bearer {$accessToken}";
        $headers[] = 'Dropbox-Api-Arg: '. json_encode($args) ;
        $headers[] = 'Content-Type: application/octet-stream';
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $result = curl_exec($ch);
        if (curl_errno($ch)) {
            echo 'Error:' . curl_error($ch);
        }
        curl_close($ch);

        return json_decode($result,true);
    }

    public function getSharedLink($accessToken, $path){
        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, 'https://api.dropboxapi.com/2/sharing/create_shared_link_with_settings');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, "{\"path\":\"{$path}\",\"settings\":{\"requested_visibility\":{\".tag\":\"public\"}}}");

        $headers = array();
        $headers[] = "Authorization: Bearer {$accessToken}";
        $headers[] = 'Content-Type: application/json';
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $result = curl_exec($ch);
        if (curl_errno($ch)) {
            echo 'Error:' . curl_error($ch);
        }
        curl_close($ch);

        return json_decode($result,true);
    }

    public function getPreviewLink($path, $accessToken){
        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, 'https://api.dropboxapi.com/2/files/get_temporary_link');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, "{\"path\": \"{$path}\"}");

        $headers = array();
        $headers[] = "Authorization: Bearer {$accessToken}";
        $headers[] = 'Content-Type: application/json';
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $result = curl_exec($ch);
        if (curl_errno($ch)) {
            echo 'Error:' . curl_error($ch);
        }
        curl_close($ch);

        return $result;
    }

    public function deleteFile($accessToken, $path){
        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, 'https://api.dropboxapi.com/2/files/delete_v2');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, "{\"path\":\"{$path}\"}");

        $headers = array();
        $headers[] = "Authorization: Bearer {$accessToken}";
        $headers[] = 'Content-Type: application/json';
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $result = curl_exec($ch);
        if (curl_errno($ch)) {
            echo 'Error:' . curl_error($ch);
        }
        curl_close($ch);

        return $result;
    }

    public function getAllFolders($accessToken, $path = null, $args = array()){
        // Generated by curl-to-PHP: http://incarnate.github.io/curl-to-php/
        $ch = curl_init();

        if($path !== null){
            $post = array(
                'path' => '/'.$path
            );
        }else{
            $post = array('path'=>'');
        }

        if(!empty($args['cursor'])){
            $post = array( 'cursor' => $args['cursor'] );
            $url = 'https://api.dropboxapi.com/2/files/list_folder/continue';
        }else{
            $url = 'https://api.dropboxapi.com/2/files/list_folder';
        }

        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($post));

        $headers = array();
        $headers[] = "Authorization: Bearer {$accessToken}";
        $headers[] = 'Content-Type: application/json';
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $result = curl_exec($ch);
        if (curl_errno($ch)) {
            echo 'Error:' . curl_error($ch);
        }
        curl_close($ch);

        $r = json_decode( $result, true );
        
        if(isset($r['entries'])){
            $return = array(
                'status' => 1,
                'data' => $r['entries']
            );
            if(isset($r['has_more'])){
                $return['cursor'] = $r['cursor'];
            }
        }else{
            $return = array(
                'status' => 0,
                'data' => array()
            );
        }


        return $return;
    }

    public function recursiveGetAllFolders($accessToken, $folderId, $parentName, &$fileLists){
		$r = $this->getAllFolders($accessToken, $folderId);
		//$fileLists = array();
		if(isset($r['status']) && $r['status']){
			$fr = $r['data'];
			if(!empty($fr)){
				foreach($fr as $gfile){
					$nm = $parentName . '/' . $gfile['name'];
					if($gfile['.tag'] == 'folder'){
						$ar = $this->recursiveGetAllFolders($accessToken, $gfile['path_display'], $nm, $fileLists);
					}else{
						$fileLists[] = array(
							'id' => $nm,
							'name' => $nm
						);
					}
				}
			}
		}
		return $fileLists;
	}

    public function getSharedFiles($accessToken, $path){
        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, 'https://api.dropboxapi.com/2/sharing/list_shared_links');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, "{\"path\":\"{$path}\"}");

        $headers = array();
        $headers[] = "Authorization: Bearer {$accessToken}";
        $headers[] = 'Content-Type: application/json';
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $result = curl_exec($ch);
        if (curl_errno($ch)) {
            echo 'Error:' . curl_error($ch);
        }
        curl_close($ch);

        return $result;
    }
}
?>